System.Gadget.onSettingsClosed = SettingsClosed;
System.Gadget.settingsUI = "settings.html";
window.onload = Init;
var timer;

function Init(){
	debugLog("Init()");
	size = read("size")||1; 
	pos = parseInt(read('pos')||'9');
	locale = read('locale')||locale;
	showGreeting = read('showGreeting')||true;
	animalText = animal.addTextObject('', "Arial", 10, "Black", 0,0);
	setAnimal(pos);
}

function SettingsClosed(){
	setAnimal(pos);
}

function getAnimalImageName(i){
	debugLog('getAnimalImageName():i=' + i + ', return = ' + animals.en[i]);
	return animals.en[i];
}

function getAnimalName(i){
	return animals[locale][i];
}

function doubleClick(){ //--> next animal
	debugLog("double click event");
	setAnimal((pos+1)%animals.en.length);
	debugLog("config: pos=" + pos);
	write('pos',pos);
}

function mouseOver(){
	if(!showGreeting) return;
	debugLog("mouseOver()");
	clearTimeout(timer);
	if(animalText.opacity == 0) 
		setAnimalText();
	animateText("show");
}

function mouseOut(){
	if(!showGreeting) return;
	debugLog("mouseOut()");
	clearTimeout(timer);
	animateText("hide");
}


function animateText(mode){
	if(mode == "hide"){
		if(animalText.opacity <= 10) 
		{
			animalText.opacity = 0;
			clearTimeout(timer);
			return;
		}
		//debugLog("animateText('hide'): opacity=" + animalText.opacity);
		animalText.opacity=animalText.opacity-3;
		timer = setTimeout('animateText("hide")',17);
	}
	else{	
		if(animalText.opacity >= 90) 
		{
			animalText.opacity = 100;
			clearTimeout(timer);
			return;
		}
		//debugLog("animateText('else'): opacity=" + animalText.opacity);
		animalText.opacity=animalText.opacity+4;
		timer = setTimeout('animateText("show")',10);
	}
}

function setAnimal(position){
	document.body.style.width = animal.style.width = Math.ceil(256/size);
	document.body.style.height = animal.style.height = Math.ceil(256/size);
	debugLog("setAnimal():position=" + position);
	pos = position;
	debugLog("setting animal: " + getAnimalImageName(pos));
	animal.src = 'images/' + animals.root + '/' + getAnimalImageName(pos) +'.png';
	setAnimalText();
}

function setAnimalText(){
	debugLog("setting animal text: " + animalText.value);
	//animalText.value = "Hey " + username + "!\nHow's it goin'?\nI'm " + getAnimalImageName(pos) + ".\nPretty neat, eh?"
	animalText.value = showGreeting ? getAnimalName(pos) : '';
	animalText.top = Math.ceil(220/size);
	animalText.left = 5;
	//animalText.top = 10;
	//animalText.left = 256;
	animalText.fontSize = 10/size+4;
	animalText.font = 'Segoe UI';
	animalText.addGlow("white", 5-size,50);
	//animalText.rotation = 90;
}

function read(a){return System.Gadget.Settings.read(a);}
function write(a,b){return System.Gadget.Settings.write(a,b);}
